﻿// gdplayer 0.9.8 Vista/7
/*
 *    gdplayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    gdplayer is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 */
// http://gdplayer.blogspot.com

var opt_stream = new Array();
var opt_group = new Array();
var opt_id = 0;
var np_id = System.Gadget.Settings.read("last_stream");

function onOpen() {
	opt_stream = System.Gadget.document.parentWindow.stream;
	opt_group = System.Gadget.document.parentWindow.group;
	fnUpdateLstGroups();
}

// ------------------------------------------------------------------- GROUP TOOLS
function fnUpdateLstGroups() {
	lst_groups.options.length = opt_group.length;
	if(!np_id) { np_id = 0; }
	for (var i = 0; i < opt_group.length; i++) {
		lst_groups.options[i].text = opt_group[i];
		
		if  (np_id >= 0) { 
			if (opt_group[i] == opt_stream[np_id].group) { lst_groups.selectedIndex = i; }
		} else {
			lst_groups.selectedIndex = 0; 
		}
	}
	fnUpdateLstStreams();
}

// ------------------------------------------------------------------- STREAMS TOOLS
function fnUpdateLstStreams() {
	if (opt_stream.length == 0) { return; }
	var id =lst_groups.selectedIndex;
	lst_stations.options.length = 0;
	var x = -1;
	for (var i = 0; i < opt_stream.length; i++) {	
		if (opt_stream[i].group == lst_groups.options[id].text) {
			lst_stations.options.length++;
			x++;
			lst_stations.options[x].text = opt_stream[i].name;
			lst_stations.options[x].alt = opt_stream[i].name;
			if (i == np_id) { lst_stations.selectedIndex = x; }
		}
	}	
}

//----------------------------------------------------------------------------------- GET ID!
function fnGetId() {
	try {
		var name = lst_stations.options[lst_stations.selectedIndex].text;	
		var group = opt_group[lst_groups.selectedIndex];
	} catch(e) { 
		return; 
	}
	var id = null;
	
	for (var i = 0; i < opt_stream.length; i++) {
		if (group == opt_stream[i].group && name == opt_stream[i].name) { id = i; }
	}	
	//alert("fnGetId : [" + id + "] " + name + " - " + group);
	opt_id = id;
	return id;
}

function fnPlayID() {
	var id = fnGetId();
	var temp_id = id;
	if (id == null) { return; }
	System.Gadget.document.parentWindow.id = id;
	System.Gadget.document.parentWindow.temp_id = temp_id;
	System.Gadget.document.parentWindow.fnPlay();
}
// ----------------------------------------------------------------------------------------------------------------------------------- XML ENCODE / DECODE
function xmlencode(string) {
    return string.replace(/&/g,"%26").replace(/</g,"%3C").replace(/>/g,"%3E").replace(/'/g,"%27").replace(/"/g,"%22");
}
function xmldecode(string) {
	return string.replace(/%26/g, "&").replace(/%3C/g, "<").replace(/%3E/g, ">").replace(/%27/g, "'").replace(/%22/g, "\"");
}
